<?php

/**
 * @file
 * Forminspect display plugin
 */

/**
 * Returns form information to be embeded in the form described
 */
function forminspect_display_form($form, $form_state, $form_id) {
  return array(
    '#type' => 'fieldset',
    '#title' => t('@form_id information', array('@form_id' => $form_id)),
    '#weight' => 1000,
    'forminspect_form' => array(
      '#type' => 'fieldset',
      '#title' => t('Form array'),
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
      'forminspect_form_contents' => array(
        '#markup' => '<div class="forminspect-dump"><pre>' . check_plain(print_r($form, TRUE)) . '</pre></div>',
      ),
    ),
    'forminspect_form_state' => array(
      '#type' => 'fieldset',
      '#title' => t('Form state'),
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
      'forminspect_form_contents' => array(
        '#markup' => '<div class="forminspect-dump"><pre>' . check_plain(print_r($form_state, TRUE)) . '</pre></div>',
      ),
    ),
  );
}

/**
 * Returns form information to be inserted in a region
 * 
 * Add collapsible and collapsed attributes as per comment #10 in http://drupal.org/node/1099132
 * to add collapsible functionality to renderable array elements
 */
function forminspect_display_region($form, $form_state, $form_id) {
  drupal_add_library('system', 'drupal.collapse');
  return array(
    '#type' => 'fieldset',
    '#title' => t('@form_id information', array('@form_id' => $form_id)),
    '#attributes' => array('class' => array('collapsible', 'collapsed')),
    'forminspect_form' => array(
      '#type' => 'fieldset',
      '#title' => t('Form array'),
      '#attributes' => array('class' => array('collapsible', 'collapsed')),
      'forminspect_form_contents' => array(
        '#markup' => '<div class="forminspect-dump"><pre>' . check_plain(print_r($form, TRUE)) . '</pre></div>',
      ),
    ),
    'forminspect_form_state' => array(
      '#type' => 'fieldset',
      '#title' => t('Form state'),
      '#attributes' => array('class' => array('collapsible', 'collapsed')),
      'forminspect_form_contents' => array(
        '#markup' => '<div class="forminspect-dump"><pre>' . check_plain(print_r($form_state, TRUE)) . '</pre></div>',
      ),
    ),
  );
}